DECLARE SUB savemins ()
DECLARE SUB savehours ()
DECLARE SUB savedays ()
DECLARE SUB shorttime ()
DECLARE SUB convert ()
DECLARE SUB startup ()
DECLARE SUB resetcount ()
DECLARE SUB calibrate ()
DECLARE SUB setspeed ()
DECLARE SUB setcom ()
COMMON SHARED comport, CM$, st, vr, zr, d, timestep, hoursfile$, daysfile$, minsfile$, tsec, dy, hr, mn, factor
DIM SHARED day(60), hour(24), min(60)
CALL setcom
OPEN CM$ FOR OUTPUT AS #1
CLOSE #1
ON ERROR GOTO handler
vr = 4.88: REM enter reference voltage here
zr = 126: REM enter millivolt offset here
factor = vr / 4.095
hoursfile$ = "c:\junk\hour"
daysfile$ = "c:\junk\day"
minsfile$ = "c:\junk\min": REM path and file names for data files
CALL setspeed: REM adjusts timer to give about 20 seconds conversion time
CALL startup: REM prepares files and sets up data converter for first conversion
CALL calibrate
totmin = 0
tothr = 0
timestep = 60
PRINT "Starting data taking in one minute."
FOR dy = 1 TO 60: REM 60 days
FOR hr = 1 TO 24: REM 24 hours
FOR mn = 1 TO 60: REM 60 minutes
26 IF tsec > VAL(MID$(TIME$, 1, 2)) * 3600 + VAL(MID$(TIME$, 4, 2)) * 60 + VAL(MID$(TIME$, 7, 2)) THEN tsec = VAL(MID$(TIME$, 1, 2)) * 3600 + VAL(MID$(TIME$, 4, 2)) * 60 + VAL(MID$(TIME$, 7, 2)): REM hopefully takes care of midnight
IF tsec + timestep > VAL(MID$(TIME$, 1, 2)) * 3600 + VAL(MID$(TIME$, 4, 2)) * 60 + VAL(MID$(TIME$, 7, 2)) THEN SLEEP (1): GOTO 26: REM wait here until timestep passes
tsec = tsec + timestep
CALL convert
d = 27 + INT(d * factor - zr) / 1000: REM gives volts with millivolt resolution
CALL savemins
totmin = totmin + d
PRINT d, "minute "; mn; " "; TIME$
NEXT mn
d = totmin / 60
CALL savehours
totmin = 0
tothour = tothour + d
NEXT hr
d = tothour / 24
CALL savedays
tothour = 0
NEXT dy
PRINT "end of data taking"
END
handler:
SELECT CASE ERR
        CASE 53
                PRINT "a file not found...continuing"
                RESUME NEXT
        CASE ELSE
                PRINT "device="; ERDEV$; " error="; ERDEV
                END
END SELECT
END

SUB calibrate
PRINT "do you wish to modify the calibration coefficients? (y or n)"
INPUT ans$
IF ans$ = "n" THEN GOTO 111
1234 PRINT "Reference volts is"; vr
PRINT "enter new reference voltage"
INPUT vr
PRINT "Offset volts is"; zr
PRINT "enter new offset voltage"
INPUT zr
111 CALL convert
d = 27 + INT(d * vr / 4.095 - zr) / 1000
PRINT "pressure ="; d
PRINT "is this correct (y or n). If you answer no, you must enter coefficients"
INPUT ans$
IF ans$ = "n" THEN 1234
END SUB

100 SUB convert
105 REM Returns d between 1 and 4095
110 CALL resetcount
130 FOR y = 1 TO 4095
140 a = INP(comport + 6) AND 128
150 IF a = 0 AND b = 128 THEN d = y
155 b = a
160 OUT comport + 4, 3: CALL shorttime
170 OUT comport + 4, 2: CALL shorttime: CALL shorttime
180 NEXT y
END SUB

2950 SUB resetcount
2960 OUT comport + 3, 64: CALL shorttime
2970 OUT comport + 3, 0: SLEEP (1)
END SUB

SUB savedays

OPEN daysfile$ FOR OUTPUT AS #5
FOR cnt = 1 TO 59
day(cnt) = day(cnt + 1)
PRINT #5, "<tr><td>"; day(cnt); "</td></tr>"
NEXT cnt
day(60) = d
PRINT #5, "<tr><td>"; day(60); "</td></tr>"
CLOSE #5

END SUB

SUB savehours
OPEN hoursfile$ FOR OUTPUT AS #4
FOR cnt = 1 TO 23
hour(cnt) = hour(cnt + 1)
PRINT #4, "<tr><td>"; hour(cnt); "</td></tr>"
NEXT cnt
hour(24) = d
PRINT #4, "<tr><td>"; hour(24); "</td></tr>"
CLOSE #4

END SUB

SUB savemins
OPEN minsfile$ FOR OUTPUT AS #1
FOR cnt = 1 TO 59
min(cnt) = min(cnt + 1)
PRINT #1, "<tr><td>"; min(cnt); "</td></tr>"
NEXT cnt
min(60) = d
PRINT #1, "<tr><td>"; min(60); "</td></tr>"
CLOSE #1

END SUB

SUB setcom
PRINT "enter com port (1,2,3, or 4)"
INPUT x3
CM$ = "COM1": comport = 1016
IF x3 = 2 THEN CM$ = "COM2": comport = 760
IF x3 = 3 THEN CM$ = "COM3": comport = 1000
IF x3 = 4 THEN CM$ = "COM4": comport = 744
PRINT "port will be "; CM$
END SUB

SUB setspeed
st = 2
REM t1 = TIMER
REM CALL convert
REM t1 = TIMER - t1
REM IF t1 < 20 THEN st = INT(st * 20 / t1): REM adjusts st for about 20 second conversion speed
END SUB

SUB shorttime
FOR z = 1 TO st
NEXT z
END SUB

900 SUB startup
910 CLS
915 PRINT "erase existing files (y or n)": INPUT r$
IF r$ = "y" THEN KILL hoursfile$
IF r$ = "y" THEN KILL daysfile$
IF r$ = "y" THEN KILL minsfile$
920 OUT &H2FB, 0
930 OUT &H2FC, 2
950 tsec = VAL(MID$(TIME$, 1, 2)) * 3600 + VAL(MID$(TIME$, 4, 2)) * 60 + VAL(MID$(TIME$, 7, 2))
END SUB

